﻿// Copyright 2009 Oliver Sturm <oliver@sturmnet.org> All rights reserved. 

#light

// Look at this function - it is not generic, but typed to 
// work with ints
let add x y = x + y

// This is a generic add function
let genericAdd f x y = f x y

// Using partial application with the standard + operation 
// creates an int specific function based on the generic
let IntAdd = genericAdd (+)

// Since the + operation is cast automatically based on type
// inference, it it sufficient to specify the type of the 
// result function explicitly in order to create a 
// float specific add function from the generic
let FloatAdd:float->float->float = genericAdd (+)

printfn "%d" (IntAdd 37 5)
printfn "%f" (FloatAdd 10.5 11.3)
