﻿#light

type Person(name:string)=
    member x.Name=name
    
    override x.ToString() = name
    
open System
open System.Drawing
open System.Windows.Forms

type MyForm() as myform =
    inherit Form(
        Text="Filtered List",
        ClientSize=Size(660, 360),
        Font=new Font("Microsoft Sans Serif", float32(18), FontStyle.Regular, GraphicsUnit.Point, byte(0)))
        
    let displayListBox = 
        new ListBox(Location=Point(16, 16), Size=Size(440, 320))
    let filterTextBox = 
        new TextBox(Location=Point(470, 16), Size=Size(175, 35))
    let button = 
        new Button(Text="Filter", Location=Point(470, 65), Size=Size(175,50))
      
    let people = new System.Collections.Generic.List<Person>()
       
    do myform.InitializeComponent()
    do myform.InitData()

    member x.InitializeComponent() = 
        base.Controls.Add(displayListBox)
        base.Controls.Add(filterTextBox)
        base.Controls.Add(button)
        button.Click.AddHandler(new EventHandler(fun s e -> x.ButtonClick(s, e)))

    member x.InitData() = 
        people.Add(Person("Anna"))
        people.Add(Person("Chris"))
        people.Add(Person("Willy"))
        people.Add(Person("Hugh"))
        people.Add(Person("Steve"))
        people.Add(Person("Betty"))
        people.Add(Person("Carla"))
        people.Add(Person("John"))
        people.Add(Person("Pete"))
        people.Add(Person("Susan"))
        
        x.UpdateUI()
        
    member x.UpdateUI() = 
        displayListBox.DataSource <- (x.GetFilteredList (x.GetFilterString()) :> System.Collections.Generic.IList<Person>)
    
    member x.GetFilterString() = filterTextBox.Text
    
    member x.GetFilteredList filter =
        match filter with 
        | "" -> people
        | _ -> new System.Collections.Generic.List<Person>(Seq.filter (fun (p:Person) -> p.Name.Contains(filter)) people)
    
    member x.ButtonClick(s, e) = 
        x.UpdateUI()
   
let form = new MyForm()
Application.Run(form)
